QA test to exercise unwritten extent conversion for sync direct I/O
[xfstests-dev.git] / 013
1 #! /bin/sh
2 # FS QA Test No. 013
3 #
4 # fsstress
5 #
6 #-----------------------------------------------------------------------
7 # Copyright (c) 2000-2002 Silicon Graphics, Inc.  All Rights Reserved.
8 #-----------------------------------------------------------------------
9 #
10 # creator
11 owner=dxm@sgi.com
12
13 seq=`basename $0`
14 echo "QA output created by $seq"
15
16 here=`pwd`
17 tmp=/tmp/$$
18 status=0        # success is the default!
19 trap "_cleanup; exit \$status" 0 1 2 3 15
20
21 _cleanup()
22 {
23     cd /
24     # we might get here with a RO FS
25     mount -o remount,rw $TEST_DEV >/dev/null 2>&1
26     # now remove fsstress directory.
27     # N.B. rm(1) on IRIX can find problems when building up a long pathname
28     # such that what it has is greater the 1024 chars and will
29     # stop and complain - so get rid of complaint
30     # Ref. pv#935754
31     rm -rf $testdir/fsstress.$$.* 2>&1 | grep -v 'Path too long'
32     _cleanup_testdir
33 }
34
35 _filesize()
36 {
37     ls -l $1 | $AWK_PROG '{print "    filesize = " $5}'
38 }
39
40 # get standard environment, filters and checks
41 . ./common.rc
42 . ./common.filter
43
44 _do_test()
45 {
46     _n="$1"
47     _param="$2"
48     _count="$3"
49
50     out=$testdir/fsstress.$$.$_n
51     rm -rf $out
52     if ! mkdir $out
53     then
54         echo "    failed to mkdir $out"
55         status=1
56         exit
57     fi
58
59     echo ""
60     echo "-----------------------------------------------"
61     echo "fsstress.$_n : $_param"
62     echo "-----------------------------------------------"
63     # -m limits number of users/groups so check doesn't fail (malloc) later
64     dbgoutfile=$seq.full
65     if ! $FSSTRESS_PROG $_param $FSSTRESS_AVOID -v -m 8 -n $_count -d $out >>$dbgoutfile 2>&1
66     then
67         echo "    fsstress (count=$_count) returned $? - see $seq.full"
68         echo "--------------------------------------"       >>$here/$seq.full
69         echo "$_n - output from fsstress:"                  >>$here/$seq.full
70         echo "--------------------------------------"       >>$here/$seq.full
71         echo "<NOT LOGGED>"                                 >>$here/$seq.full
72         #cat $tmp.out                                       >>$here/$seq.full
73         status=1
74     fi
75
76     _check_test_fs
77 }
78
79
80 # real QA test starts here
81 _supported_fs xfs udf
82 _supported_os IRIX Linux
83
84 _setup_testdir
85
86 rm -f $here/$seq.full
87 echo "brevity is wit..."
88
89 count=1000
90 procs=20
91
92 _check_test_fs
93
94 # the default
95
96 _do_test 1 "-r" $count
97
98 # and the default with multiprocess
99
100 _do_test 2 "-p $procs -r" $count
101
102 # from Glen's notes
103
104 _do_test 3 "-p 4 -z -f rmdir=10 -f link=10 -f creat=10 -f mkdir=10 -f rename=30 -f stat=30 -f unlink=30 -f truncate=20" $count
105
106 # if all ok by here then probably don't need $seq.full
107 rm -f $seq.full
108
109 exit
110
111 # Test with error injection:
112 #
113 # (error injection)
114 # fsstress -n 1000 -d $scratch -p 4 -z -f rmdir=10 -f link=10 -f creat=10 \
115 #          -f mkdir=10 -f rename=30 -f stat=30 -f unlink=30 -f truncate=20 \
116 #          -e 1
117 #
118 # Error values 1 - 6 test IFLUSH
119 #         1 - corrupt buffer being flushed to di_core.di_magic
120 #         2 - corrupt inode being flushed i_d.di_magic
121 #         3 - corrupt S_IFREG format check
122 #         4 - corrupt S_IFDIR format check
123 #         5 - corrupt i_d.di_nextents
124 #         6 - corrupt i_d.di_forkoff > sb_inodesize